#include <bits/stdc++.h>
using namespace std;

const int NMAX = 250005;

int n, a[NMAX];
long long sol;

void Go(int st, int dr)
{
	if (st == dr) {sol++; return ;}

	int mij = (st + dr) / 2;

	Go(st, mij);
	Go(mij + 1, dr);

	//make left suffixes
	map<int, int>M, fr;
	for (int i = mij; i >= st; i--)
	{
		fr[a[i]]++;
		if (fr[a[i]] >= (mij - i + 1) / 2 + 1) M[a[i]] = 1;
	}

	fr.clear();
	for (int i = mij + 1; i <= dr; i++)
	{
		fr[a[i]]++;
		if (fr[a[i]] >= (i - mij) / 2 + 1) M[a[i]] = 1;
	}

	//for every maj make sums
	int ADD = dr - st + 1, lim = 2*(dr - st + 5);
	int* freq = (int*)malloc(lim*sizeof(int)); //frequencies for left sums
	for (auto it : M)
	{
		memset(freq, 0, lim*sizeof(int));
		int act = 0;
		freq[0 + ADD]++;
		for (int i = st; i <= mij; i++)
		{
			if (a[i] == it.first) act++;
			else act--;
			if (i < mij) freq[act + ADD]++;
		}

		for (int i = 1; i < lim; i++) freq[i] += freq[i - 1];

		//go through right sums, act remains
		for (int i = mij + 1; i <= dr; i++)
		{
			if (a[i] == it.first) act++;
			else act--;

			sol += freq[act + ADD - 1];
		}
	}

	free(freq);
}

int main()
{	
	freopen("bvarcolaci.in", "rb", stdin);
	freopen("bvarcolaci.out", "wb", stdout);
	//cin.sync_with_stdio(false);

	cin >> n;
	for (int i = 1; i <= n; i++) cin >> a[i];

	Go(1, n);

	cout << sol << "\n";
	return 0;
}
