#include <cassert>
#include <fstream>
#include <cstring>
#include <queue>
#include <algorithm>
#include <bitset>
#include <ctime>
#include <set>
#include <cmath>
#include <random>
#include <iomanip>
#include <map>
#include <stack>
#include <vector>
#include <bitset>
#include <iostream>

using namespace std;

#define FOR(i, a, n) for (int i = a; i <= n; ++i)
#define ROF(i, n, a) for (int i = n; i >= a; i--)
#define FIT(i, v) for (auto &i : v)
#define pb push_back
#define mp make_pair
#define mt make_touple
#define all(x) (x).begin(), (x).end()
#define fi first
#define se second
#define sz(x) ((int)(x).size())
#define log log2
typedef long long ll;
typedef pair<int,int> pii;
const int mod = 1000000007;
ll powmod(ll a, ll b) {ll res=1; a %= mod; assert(b >= 0); for(; b; b >>= 1) {if (b & 1) res = res * a % mod; a = a * a % mod;} return res;}

ifstream f("bvarcolaci.in");
ofstream g("bvarcolaci.out");

const int DIM = 8000100;
const int maxN = 1000000;
const int N = maxN + 100;

ll sol, prog[N << 2];
vector<int> poz[N];
int sum[N << 2], lef[N << 2], rig[N << 2], nods, n, x, buf;
char b[DIM];

void gInt(int &x) {
    x = 0;
    while (b[buf] > '9' || b[buf] < '0') {
        ++buf;
    }
    while (b[buf] >= '0' && b[buf] <= '9') {
        x = x * 10 + b[buf++] - '0';
    }
}

void push(int nod, int st, int dr) {
    int mij = (st + dr) >> 1;
    if (!lef[nod]) {
        lef[nod] = ++nods;
    }
    if (!rig[nod]) {
        rig[nod] = ++nods;
    }
    if (sum[nod] != sum[lef[nod]] + sum[rig[nod]]) {
        int dif = (sum[nod] - (sum[lef[nod]] + sum[rig[nod]])) / (dr - st + 1);
        sum[lef[nod]] += (mij - st + 1) * dif;
        sum[rig[nod]] += (dr - mij) * dif;
        prog[lef[nod]] += 1LL * (mij - st + 1) * (mij - st + 2) / 2 * dif;
        prog[rig[nod]] += 1LL * (dr - mij) * (dr - mij + 1) / 2 * dif;
    }
}

void upd(int nod, int st, int dr, int l, int r) {
    if (st >= l && dr <= r) {
        sum[nod] += (dr - st + 1);
        prog[nod] += 1LL * (dr - st + 1) * (dr - st + 2) / 2;
        return;
    }
    push(nod, st, dr);
    int mij = (st + dr) >> 1;
    if (l <= mij) {
        upd(lef[nod], st, mij, l, r);
    }
    if (r > mij) {
        upd(rig[nod], mij + 1, dr, l, r);
    }
    sum[nod] = sum[lef[nod]] + sum[rig[nod]];
    prog[nod] = prog[lef[nod]] + prog[rig[nod]] + 1LL * sum[lef[nod]] * (dr - mij);
}

void qryp(int nod, int st, int dr, int l, int r) {
    if (st >= l && dr <= r) {
        sol += prog[nod] + 1LL * sum[nod] * (r - dr);
        return;
    }
    push(nod, st, dr);
    int mij = (st + dr) >> 1;
    if (l <= mij) {
        qryp(lef[nod], st, mij, l, r);
    }
    if (r > mij) {
        qryp(rig[nod], mij + 1, dr, l, r);
    }
}

void qrys(int nod, int st, int dr, int l, int r, int m) {
    if (st >= l && dr <= r) {
        sol += 1LL * sum[nod] * m;
        return;
    }
    push(nod, st, dr);
    int mij = (st + dr) >> 1;
    if (l <= mij) {
        qrys(lef[nod], st, mij, l, r, m);
    }
    if (r > mij) {
        qrys(rig[nod], mij + 1, dr, l, r, m);
    }
}
int main() {
    f.get(b, DIM, EOF);
    gInt(n);
    //    assert(1 <= n && n <= maxN);
    FOR(i,1,n) {
        poz[i].pb(0);
    }
    FOR(i,1,n) {
        gInt(x);
        //        assert(1 <= x && x <= n);
        poz[x].pb(i);
    }
    FOR(i,1,n) {
        poz[i].pb(n + 1);
    }
    FOR(i,1,n) {
        while(nods) {
            lef[nods] = rig[nods] = sum[nods] = prog[nods] = 0;
            --nods;
        }
        ++nods;
        for (int j = 0; j < poz[i].size() - 1; ++j) {
            int cs = j * 2 - poz[i][j];
            int dist = poz[i][j + 1] - poz[i][j];
            if (j) {
                qryp(1, -n, n, cs - 1 - dist + 1, cs - 1);
                if (cs - 1 - dist - 1 >= -n) {
                    qrys(1, -n, n, -n, cs - 1 - dist, dist);
                }
            }
            if (!j) {
                upd(1, -n, n, -dist + 1, 0);
            } else {
                upd(1, -n, n, cs - dist + 1, cs);
            }
        }
    }
    g << sol;
    return 0;
}
