///100 p - prof. Eugen Nodea
# include <bits/stdc++.h>
# define NMax 2000001
using namespace std;

const int INF = 2e9;

int st[NMax], dr[NMax];
int start_st[NMax], start_dr[NMax];
int n, m, p,q;

void construieste( int n )
{
    int N = n;
    for(int i=0; i<N; ++i){
        start_st[i] = INF;
        start_dr[i] = -INF;
    }

    start_st[0] = start_dr[0] = 0;
    for(int i=0; i<N-1; ++i){
        start_dr[i] = min(start_dr[i], st[i]);
        if(start_st[i] + p>= n)
            continue;
        if(start_st[i] > start_dr[i])
            return;
        if(start_dr[i] + q - 1 < dr[i])
            return;
        start_dr[i + 1] = min(n - 1, start_dr[i] + q);
        start_dr[i + 1] = min(start_dr[i + 1], st[i + 1] + q - 1);
        start_st[i + 1] = max(dr[i] + 1, start_st[i] + p);
        start_st[i + 1] = max(start_st[i + 1], dr[i + 1] - q + 1);
    }

}
int main()
{
    freopen("startrek.in", "r", stdin);
    freopen("startrek.out","w", stdout);

	scanf("%d %d %d %d", &n, &p, &q, &m);
	vector <int> a(n);
	for(int i=1; i<=m; ++i){
        int s, t;
        scanf("%d %d", &s, &t);
        a[s-1] = t;
	}

    for(int i=0; i<n; ++i){
        st[i] = INF; /// indicele sectorul de inceput(stanga) al unui an
        dr[i] =-INF; /// indicele sectorul de sfarsit al anului respectiv
    }

    int ultima_trs = 0; ///determinam ultima transmisie
    for(int i=0; i<n; ++i) {
        if(a[i]) {
            a[i]--;
            ultima_trs  = max(ultima_trs, a[i]);
            st[a[i]] = min(st[a[i]], i);
            dr[a[i]] = max(dr[a[i]], i);
        }
    }

    ///incercam sa umplem
    construieste( n );

    /// determin timpul maxim
    int an = -1;
    for(int j = ultima_trs; j < n; ++j) {
       if(start_st[j] > start_dr[j])
           continue;
       if( n - start_st[j] >= p && n - start_dr[j] <= q ){
           an = j;
       }
    }

    printf("%d\n", an + 1);

    int poz = n - 1;
    for(; an >= 0; --an) {
        int j = min(poz, start_dr[an]);
        for(; j >= 0 ; --j){
            if(poz - j + 1 >= p && poz - j + 1 <= q){
                break;
            }
        }
        /// umplu
        for(int i = j; i <= poz; ++i){
            a[i] = an + 1;
        }
        poz = j - 1;
    }

    for(int i=0; i<n; ++i){
        printf("%d ", a[i]);
    }

    return 0;
}
