/*
    Radu
    O(n)?
*/

#include <iostream>
#include <cstdio>
#include <algorithm>

using namespace std;

const int Q=1000000;

int n,p,q,m;

struct tipe
{
	int poz;
	int val;
} v[Q];

bool operator <(const tipe &a, const tipe &b)
{
	if(a.val!=b.val)
		return a.val<b.val;
	return a.poz<b.poz;
}


int puse[Q];
int max_bl[Q];
int disp[Q];
//int capat_dr[Q];
int pnt[Q];

int aib[Q];

int ask(int poz)
{
    int rez=0;
    while(poz)
    {
        rez+=aib[poz];
        poz-=poz&(-poz);
    }
    return rez;
}

void update(int val,int poz)
{
   while(poz<Q)
   {
        aib[poz]+=val;
        poz+=poz&(-poz);
   }
}



int elibereaza(int no,int cursor, int pozitie)
{
    int loc=no;

    while(cursor>=pozitie)
    {
        while(disp[pnt[loc]]==0)
        {
            pnt[loc]=pnt[pnt[loc]];
        }
        loc=pnt[loc];

        if(cursor-disp[loc]>=pozitie-1)
        {
            cursor-=disp[loc];
            puse[loc]-=disp[loc];
            update(-disp[loc],loc);
           // capat_dr[loc]-=disp[loc];
            disp[loc]=0;
        }
        else
        {
            puse[loc]-=cursor-pozitie+1;
            disp[loc]-=cursor-pozitie+1;
            update(-(cursor-pozitie+1),loc);
           // capat_dr[loc]-=cursor-pozitie+1;
            cursor=pozitie-1;
            return cursor;
        }
    }
    return cursor;
}

void get_from(int need,int ultimul)
{
    for(int no=ultimul; no>0; no=pnt[no])
    {
        if(disp[no] <=need)
        {
            update(-disp[no],no);
            //capat_dr[no]-=disp[no];

            puse[no]-=disp[no];
            need-=disp[no];
            disp[no]=0;
        }
        else
        {
            puse[no]-=need;
            disp[no]-=need;
            update(-need,no);
            need=0;
            return;
        }
    }
}


int can_get(int ultimul)
{
    int rez=0;

    int max=2000000000;

    for(int no=ultimul; no>0; no=pnt[no])
    {
        if(disp[no]<=max)
        {
            max-=disp[no];
            rez+=disp[no];
        }
        else
        {
            rez+=max;
            max=0;
            break;
        }
        if(ask(no)-max_bl[no] < max)
            max=ask(no)-max_bl[no];
    }

    return rez;
}

void insereaza(int who,int cv)
{
    //who++;
	while(cv)
	{
        if(cv >= q-puse[who])
        {
            cv-=q-puse[who];
            puse[who]=q;
        }
        else
        {
            puse[who]+=cv;
            break;
        }
        who++;
	}
}

int main()
{
    freopen("startrek.in","r",stdin);
	freopen("startrek.out","w",stdout);

	scanf("%d%d%d%d",&n,&p,&q,&m);

	for(int i=1; i<=m; i++)
	{
		scanf("%d%d",&v[i].poz, &v[i].val);
	}

	std::sort(v+1,v+m+1);

	int last_val=0;
	int last_poz=0;

	int th=0;

	int cursor=0;

	int ultimul;

	for(int no=1; cursor<n || th<m; no++)
	{
        ultimul=no;
        if(disp[no-1])
        {
            pnt[no]=no-1;
        }
        else
        {
            pnt[no]=pnt[no-1];
        }

        if(v[th+1].val!=no)
        {

            update(q,no);
       //     capat_dr[no]=cursor+q;
            cursor+=q;
            puse[no]=q;
            disp[no]=q-p;

            continue;
        }

        while(v[th+1].val==no)
        {
            th++;

            max_bl[no]=v[th].poz;

            if(v[th].val==v[th-1].val)
            {

                //disp[no]=min(capat_dr[no]-v[th].poz,q-p);
                int my=ask(no);
                disp[no]=min(my-v[th].poz,q-p);
            }
            else
            {
                cursor=elibereaza(no,cursor,v[th].poz);

                update(q,no);
                //capat_dr[no]=cursor+q;
                cursor+=q;
                puse[no]=q;
                //disp[no]=min(q+capat_dr[no-1]-max_bl[no], q-p);

                int my=ask(no-1);
                disp[no]=min(q+my-max_bl[no], q-p);
            }
        }

        if(th==m)
            break;
	}

	int surplus;

    update(-disp[ultimul],ultimul);
	//capat_dr[ultimul]-=disp[ultimul];
	puse[ultimul]-=disp[ultimul];
	disp[ultimul]=0;

    int my=ask(ultimul);

    int lul=ultimul;

	surplus=n-my;

	if(surplus<0)
	{
        get_from(-surplus,ultimul-1);
        surplus=0;
	}

	surplus+=can_get(ultimul);

	surplus=(surplus/p)*p;

	my=ask(ultimul);

	int need=surplus-(n-my);

	int cv=0;

	if(need<0)
	{
        cv=-need;
        need=0;
	}

	get_from(need, ultimul);

	while(surplus>=p)
	{
        ultimul++;
        if(disp[ultimul-1])
            pnt[ultimul]=ultimul-1;
        else
            pnt[ultimul]=pnt[ultimul-1];

        surplus-=p;
        puse[ultimul]=p;
        disp[ultimul]=0;
//        capat_dr[ultimul]=capat_dr[ultimul-1]+p;
        int my=ask(ultimul-1);

        update(p,ultimul);
	}

	//afisare();

	printf("%d\n",ultimul);

	insereaza(lul,cv);


	for(int i=1; i<=ultimul; i++)
	{
        for(int j=1; j<=puse[i]; j++)
        {
            printf("%d ",i);
        }
	}



    return 0;
}

