#include <bits/stdc++.h>
using namespace std;

const int NMAX = 500005;

int n, sq, a[NMAX], fr[NMAX];
int AIB[NMAX], sum[NMAX];
vector<int>v[NMAX];
long long sol;

int zeros(int x)
{
	return x^(x&(x - 1));
}

void Update(int poz, int val)
{
	for (int i = poz; i < NMAX; i += zeros(i)) AIB[i] += val;
}

int Query(int poz)
{
	int i, rez = 0;
	for (int i = poz; i >= 1; i -= zeros(i)) rez += AIB[i];

	return rez;
}

int main()
{
	freopen("bvarcolaci.in", "r", stdin);
	freopen("bvarcolaci.out", "w", stdout);

	scanf("%d", &n); sq = sqrt(n);
	for (int i = 1; i <= n; i++)
	{
		scanf("%d", &a[i]);
		v[a[i]].push_back(i);
	}

	//brute small
	for (int i = 1; i <= n; i++)
	{
		int mx = 0;
		for (int j = i; j >= 1 && (i - j + 1) / 2 + 1 <= sq; j--)
		{
			fr[a[j]]++;
			mx = max(mx, fr[a[j]]);
			if (mx >= (i - j + 1) / 2 + 1) sol++;
		}

		//clean
		for (int j = i; j >= 1 && (i - j + 1) / 2 + 1 <= sq; j--) fr[a[j]] = 0;
	}
	
	int ADD = n;
	//AIB for big
	for (int i = 1; i < NMAX; i++)
		if (v[i].size() > sq)
		{
			for (auto it : v[i]) sum[it]++;
			for (int j = 1; j <= n; j++) 
				{
					if (sum[j] == 0) sum[j] = -1;
					sum[j] += sum[j - 1];
				}
			int last = 0;
			for (int j = 1; j <= n; j++)
			{
				while ((j - last) / 2 + 1 > sq) //good for Update
				{
					Update(sum[last] + ADD, 1);
					last++;
				}

				sol += Query(sum[j] - 1 + ADD);
			}

			//clean
			for (int j = 0; j < last; j++) Update(sum[j] + ADD, -1);
			for (int j = 1; j <= n; j++) sum[j] = 0;
		}

	printf("%lld\n", sol);
	return 0;
}